<?php

namespace FiloBlu\ExtMailChimp\Plugin\Helper;

use Magento\Newsletter\Model\Subscriber;

/**
 * Class Data
 * @package FiloBlu\ExtMailChimp\Plugin\Helper
 */
class Data
{
    /**
     * @var \FiloBlu\ExtMailChimp\Helper\Data
     */
    private $helperData;

    /**
     * Data constructor.
     * @param \FiloBlu\ExtMailChimp\Helper\Data $helperData
     */
    public function __construct(\FiloBlu\ExtMailChimp\Helper\Data $helperData)
    {
        $this->helperData = $helperData;
    }

    /**
     * @see \Ebizmarts\MailChimp\Helper\Data::getMergeVarsBySubscriber
     *
     * @param $subject
     * @param $return
     * @param Subscriber $subscriber
     * @param null $email
     * @return array|null
     */
    public function afterGetMergeVarsBySubscriber($subject, $return, Subscriber $subscriber, $email = null)
    {
        // FORCE LOAD
        $subscriber->load($subscriber->getId());
        $data = $this->helperData->getMergeVars($subscriber, $subscriber->getStoreId()) ?? [];
        return array_filter(array_merge($return??[], $data));
    }
}
